<?php
class ControllerPaymentCEPay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/ce_pay');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('ce_pay', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}
		$this->data['heading_title'] = $this->language->get('heading_title');		
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		$this->data['entry_mertid'] = $this->language->get('entry_mertid');
		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['entry_total'] = $this->language->get('entry_total');	
		$this->data['entry_completed_status'] = $this->language->get('entry_completed_status');
		$this->data['entry_denied_status'] = $this->language->get('entry_denied_status');
		$this->data['entry_failed_status'] = $this->language->get('entry_failed_status'); 
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
 		if (isset($this->error['mertid'])) {
			$this->data['error_mertid'] = $this->error['mertid'];
		} else {
			$this->data['error_mertid'] = '';
		}		
		 if (isset($this->error['total'])) {
			$this->data['error_total'] = $this->error['total'];
		} else {
			$this->data['error_total'] = '';
		}
		$this->data['breadcrumbs'] = array();
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),      		
      		'separator' => false
   		);
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/ce_pay', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		$this->data['action'] = $this->url->link('payment/ce_pay', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		if (isset($this->request->post['ce_pay_mertid'])) {
			$this->data['ce_pay_mertid'] = $this->request->post['ce_pay_mertid'];
		} else {
			$this->data['ce_pay_mertid'] = $this->config->get('ce_pay_mertid');
		}
		if (isset($this->request->post['ce_pay_test'])) {
			$this->data['ce_pay_test'] = $this->request->post['ce_pay_test'];
		} else {
			$this->data['ce_pay_test'] = $this->config->get('ce_pay_test');
		}		
		if (isset($this->request->post['ce_pay_total'])) {
			$this->data['ce_pay_total'] = $this->request->post['ce_pay_total'];
		} else {
			$this->data['ce_pay_total'] = $this->config->get('ce_pay_total'); 
		} 	
		if (isset($this->request->post['ce_pay_completed_status_id'])) {
			$this->data['ce_pay_completed_status_id'] = $this->request->post['ce_pay_completed_status_id'];
		} else {
			$this->data['ce_pay_completed_status_id'] = $this->config->get('ce_pay_completed_status_id');
		}			
		if (isset($this->request->post['ce_pay_denied_status_id'])) {
			$this->data['ce_pay_denied_status_id'] = $this->request->post['ce_pay_denied_status_id'];
		} else {
			$this->data['ce_pay_denied_status_id'] = $this->config->get('ce_pay_denied_status_id');
		}		
		if (isset($this->request->post['ce_pay_failed_status_id'])) {
			$this->data['ce_pay_failed_status_id'] = $this->request->post['ce_pay_failed_status_id'];
		} else {
			$this->data['ce_pay_failed_status_id'] = $this->config->get('ce_pay_failed_status_id');
		}									
		$this->load->model('localisation/order_status');
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		if (isset($this->request->post['ce_pay_geo_zone_id'])) {
			$this->data['ce_pay_geo_zone_id'] = $this->request->post['ce_pay_geo_zone_id'];
		} else {
			$this->data['ce_pay_geo_zone_id'] = $this->config->get('ce_pay_geo_zone_id');
		}
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		if (isset($this->request->post['ce_pay_status'])) {
			$this->data['ce_pay_status'] = $this->request->post['ce_pay_status'];
		} else {
			$this->data['ce_pay_status'] = $this->config->get('ce_pay_status');
		}		
		if (isset($this->request->post['ce_pay_sort_order'])) {
			$this->data['ce_pay_sort_order'] = $this->request->post['ce_pay_sort_order'];
		} else {
			$this->data['ce_pay_sort_order'] = $this->config->get('ce_pay_sort_order');
		}
		$this->template = 'payment/ce_pay.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
		$this->response->setOutput($this->render());
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ce_pay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		if (!$this->request->post['ce_pay_mertid'] || !ctype_digit($this->request->post['ce_pay_mertid'])) {
			$this->error['mertid'] = $this->language->get('error_mertid');
		}		
		if ($this->request->post['ce_pay_total']<50 || !ctype_digit($this->request->post['ce_pay_total'])) {
			$this->error['total'] = $this->language->get('error_total');
		}		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>